//---------------------------------------------------------------------------

#pragma hdrstop

#include <tchar.h>
//---------------------------------------------------------------------------

//
//		Y. Okamoto 2009.10
//
#include <cmath>
#include <iostream>
#include <fstream>
#include "myLib.h"

using namespace std;
using namespace myLib;

#pragma argsused
int _tmain(int argc, _TCHAR* argv[])
{
	//
	//    ͗peLXgt@CƓ̓Xg[̐ݒ
	//
	cout << "Input data file = ";
	string fin_nm;
	cin >> fin_nm;
	RdTxtLn rd( fin_nm );
	if (rd.iCond != 0){
		cout << "To open input data file failed." << endl;
		return 9;
	}

	//
	//    o͗peLXgt@CƏo̓Xg[̐ݒ
	//
	cout << "Output file = ";
	char  fout_nm[200];
	cin >> fout_nm;
	ofstream fout( fout_nm );
	fout << "Input data file = " << fin_nm << endl << endl;

	//
	//@@@@̓t@C̐擪i"/"Ŏn܂s܂Łj̓ǂݔ΂
	//
	string s;
	int ick = 0;
	do{
		rd.readline( s );
		if (s.size() > 0)
			if (s[0] == '/') ick = 1;
	}while( ick == 0 );

	//
	//@@@f[^N𐔂
	//
	int N = 0;
	ick = 0;
	do {
		rd.readline( s );
		if (s[0] == '/'){
		ick = 1;
		} else {
			N++;
		}
	} while (ick == 0);

	//
	//@@@̓t@C̐擪ɓǂݍ݈ʒu߂
	//
	rd.close();
	rd.open(fin_nm);
	if (rd.iCond != 0){
		cout << "To re-open the inpur file failed." << endl;
		return 9;
	}

	ick = 0;
	do {
		rd.readline( s );
		if (s.size() > 0)
			if (s[0] == '/')
				ick = 1;
	} while (ick == 0);

	double * x, * y;
	x = new double[N];
	y = new double[N];
	for (int i = 0; i < N; i++) {
		rd.readline( s );
		x[i] = strToDouble(SeekStr(s, 0));
		y[i] = strToDouble(SeekStr(s, 1));
	}
	fout << "\n" << "Data..." << endl;
	for (int i = 0; i < N; i++) {
		fout << i << ": x = " << x[i] << "  \ty = " << y[i] << endl;
	}

	double sx = 0.0;
	double sy = 0.0;
	double sxx = 0.0;
	double syy = 0.0;
	double sxy = 0.0;
	for (int i = 0; i < N; i++){
		sx += x[i];
		sy += y[i];
		sxx += sqr(x[i]);
		syy += sqr(y[i]);
		sxy += x[i] * y[i];
	}
	double meanX = sx / N;
	double meanY = sy / N;
	double varX = (sxx / N) - sqr(meanX);
	double varY = (syy / N) - sqr(meanY);
	double sdX = sqrt(varX);
	double sdY = sqrt(varY);
	double Cov = (sxy / N) - (meanX * meanY);
	double r = Cov / (sdX * sdY);

	fout << endl;
	fout << "mean of x = " << meanX << endl;
	fout << "mean of y = " << meanY << endl;
	fout << "Variance of x = " << varX << endl;
	fout << "Variance of y = " << varY << endl;
	fout << "SD of x = " << sdX << endl;
	fout << "SD of y = " << sdY << endl;
	fout << "Covarince = " << Cov << endl;
	fout << "Correlation = " << r << endl;

	double uvarX = N * varX / (N - 1);
	double uvarY = N * varY / (N - 1);
	double uCov  = N * Cov / ( N - 1);

	fout << endl;
	fout << "Unbiased Var of x = " << uvarX << endl;
	fout << "Unbiased Var of y = " << uvarY << endl;
	fout << "Unbiased Cov = " << uCov << endl;
	fout << "SD(uVarX) = " << sqrt(uvarX) << endl;
	fout << "SD(uVarY) = " << sqrt(uvarY) << endl;

	rd.close();
	fout.close();
	delete [] x;
	delete [] y;

	return 0;
}
//---------------------------------------------------------------------------
